#ifndef REFLEX_APPLICATION_H
#define REFLEX_APPLICATION_H

#include <reflex/base/FileAccessObject.hpp>
#include <reflex/driver/ReflexDriver.hpp>
#include <reflex/application/ReflexCamera.hpp>


namespace reflex
{

class ReflexApplication : public FileAccessObject
{
public:

    ReflexApplication(int type = -1);
    virtual ~ReflexApplication();

    virtual void write(cv::FileStorage& fs) const;
    virtual void read(const cv::FileNode& node);

    int findCameras();
    int addCamera(const string& ipAddress);

    vector<ReflexCamera> cameraUnits;

protected:

    int _err;
    bool _debug;

    const string _dirCameraData = "/tmp/";

};

} // end namespace reflex


#endif
