#ifndef FILE_SYSTEM_H
#define FILE_SYSTEM_H

#include <reflex/reflex.hpp>
#include <boost/filesystem.hpp>


namespace reflex
{

class FileSystem
{
public:

    struct FileInfo
    {
        string path;
        string folder;
        string fileName;
        string fileNameBase;
        string fileNameEnding;
    };

    static bool exists(const string& path);
    static bool isDirectory(const string& path);
    static int removeFolder(const string& path);
    static int copyFile(const string& pathSource, const string& pathDestination, bool overwrite = false);
    static int copyFolder(const string& pathSource, const string& pathDestination, bool overwrite = false);
    static int createFolder(const string& path, bool overwrite = false);
    static int createFolderStructure(const string& path);
    static int getDirectories(const string& directory, std::vector<string>& folders);

    static FileInfo parseFileName(const string& path);

    static std::string expandEnvironmentVariables(const std::string& in);

private:

    FileSystem();

};

} // end namespace reflex



#endif
