#ifndef IMAGE_PROCESSING_H
#define IMAGE_PROCESSING_H

#include <reflex/reflex.hpp>

namespace reflex
{

class ImageProcessing
{
public:

    // copy/add image 1 to image 2 at position defined by <origin> / <rect>
    // while considering the actually overlapping parts of the images
    static void copyTo(const cv::Mat& img1, cv::Mat& img2, const cv::Point& origin, const cv::Mat& mask = cv::Mat());
    static void copyTo(const cv::Mat& img1, cv::Mat& img2, const cv::Rect& roi, const cv::Mat& mask = cv::Mat());
    static void addTo(const cv::Mat& img1, cv::Mat& img2, const cv::Point& origin, const cv::Mat& mask = cv::Mat());
    static void addTo(const cv::Mat& img1, cv::Mat& img2, const cv::Rect& roi, const cv::Mat& mask = cv::Mat());
};

} // end of namespace reflex


#endif
