#ifndef CAMERA_EXTRINSICS_H
#define CAMERA_EXTRINSICS_H

#include <reflex/base/FileAccessObject.hpp>


namespace reflex
{

class CameraExtrinsics : public FileAccessObject
{
public:

    CameraExtrinsics();
    virtual ~CameraExtrinsics();

    virtual void write(cv::FileStorage& fs) const;
    virtual void read(const cv::FileNode& node);

    CameraExtrinsics getInverse() const;

    cv::Mat R;
    cv::Vec3d rvec;     // rotation vector (rodrigues transform) corresponding to matrix R
    cv::Mat T;
    std::string camSerialNumber;
    int calibSerialNumber;

};



} // end namespace reflex

#endif
