#ifndef CAMERA_INTRINSICS_H
#define CAMERA_INTRINSICS_H

#include <reflex/base/FileAccessObject.hpp>


namespace reflex
{

class CameraIntrinsics : public FileAccessObject
{
public:

    CameraIntrinsics();
    virtual ~CameraIntrinsics();

    virtual void write(cv::FileStorage& fs) const;
    virtual void read(const cv::FileNode& node);

    CameraIntrinsics convert(const cv::Size& subsampling, const cv::Point& roiPos, const cv::Size& roiSize) const;
    CameraIntrinsics clone() const;

    void projectPointsToImage(cv::InputArray objectPoints, cv::OutputArray imagePoints, cv::InputArray rvec = cv::noArray(), cv::InputArray tvec = cv::noArray()) const;

    cv::Point2d getCenter() const { return cv::Point2d(cameraMatrix.at<double>(0,2), cameraMatrix.at<double>(1,2)); }

    cv::Size imageSize;
    cv::Mat cameraMatrix;
    cv::Mat distCoeffs;
    std::string camSerialNumber;
    int calibSerialNumber;
};


} // end namespace reflex

#endif
