#ifndef RECTIFICATION_MAP_H
#define RECTIFICATION_MAP_H

#include <reflex/base/FileAccessObject.hpp>


namespace reflex
{

class RectificationMap : public FileAccessObject
{
public:

    RectificationMap();

    virtual ~RectificationMap();

    virtual void write(cv::FileStorage& fs) const;
    virtual void read(const cv::FileNode& node);

    virtual bool empty() const { return (!map[CAM1].data || !map[CAM2].data) ? true : false; }

    cv::Mat map[2];          // two tables for x and y coordinates
    int format;              // data format of the remapping tables (CV_16S2 or CV_32FC1)
    std::string camSerialNumber;
    int calibSerialNumber;
};


} // end namespace reflex

#endif
