#ifndef SENSOR_CONFIG_H
#define SENSOR_CONFIG_H

#include <reflex/base/FileAccessObject.hpp>

namespace reflex
{

class SensorConfig : public FileAccessObject
{
public:

    enum syncMode
    {
        SYNC_UNSET,
        SYNC_STANDALONE,
        SYNC_SYNC
    };

    enum triggerSource
    {
        TRIGGER_UNSET,
        TRIGGER_INTERNAL,
        TRIGGER_EXTERNAL
    };

    enum exposureMode
    {
        EXPOSURE_TIME_FIXED,
        EXPOSURE_TIME_AUTO
    };


    SensorConfig();

    virtual ~SensorConfig();

    virtual void write(cv::FileStorage& fs) const;
    virtual void read(const cv::FileNode& node);

    int sensorID;

    bool flash;
    int syncMode;

    cv::Size binning;
    cv::Size subsampling;
    cv::Point roiPos;
    cv::Size roiSize;

    int exposureMode;
    int shutter;
    float gain;
};


} // end namespace reflex

#endif
