#ifndef REFLECTOR_H
#define REFLECTOR_H

#include <reflex/reflex.hpp>


namespace reflex
{

class Reflector
{
public:

    Reflector(const std::vector<cv::Point2i>& contour);
    virtual ~Reflector();

    void move(cv::Vec2f offset);

    std::vector<cv::Point2i> contour;
    cv::Rect box;
    cv::Vec2f pos2D;
    cv::Vec3f pos3D;
    cv::Vec2f disp;
    double area;
    double perimeter;
    float score;
    float circularity;

    static std::vector<Reflector> create(std::vector<std::vector<cv::Point2i>>& contours);
};


} // end namespace reflex



#endif
