#ifndef _REFLEX_DRIVER_DEV_H_
#define _REFLEX_DRIVER_DEV_H_

#include <opencv2/opencv.hpp>
#include "ReflexDriver.hpp"


namespace reflex
{

struct ReflexImageCV
{
    double   timestamp;
    uint32_t frame_id;
    uint32_t shutter;
    float    gain;
    int8_t   exposure_mode;
    int8_t   type;
    int8_t   sensor_id;
    cv::Mat  img;

    ReflexImageCV()
    {
        timestamp     = -1.;
        frame_id      =  0;
        shutter       =  0;
        gain          = -1.;
        exposure_mode = -1;
        type          = -1;
        sensor_id     = -1;
    }
};


int reflex_receive_image(const std::string& ip_address, int sensor_id, ReflexImageCV& image);
int reflex_receive_images(const std::string& ip_address, const std::vector<int>& sensor_ids, std::vector<ReflexImageCV>& images);
int reflex_receive_images_full(const std::string& ip_address, std::vector<ReflexImageCV>& images);

int reflex_receive_data_and_image(const std::string& ip_address, ReflexData& data, int sensor_id, ReflexImageCV& image);
int reflex_receive_data_and_images(const std::string& ip_address, ReflexData& data, const std::vector<int>& sensor_ids,  std::vector<ReflexImageCV>& images);

} // end of namespace reflex


#endif
