#ifndef REFLEX_DEFS_H
#define REFLEX_DEFS_H

#include <vector>
#include "system_defs.h"

namespace reflex
{

enum ReflexCameraUnitTypes
{
    CAMERA_UNIT_TYPE_UNDEFINED = -1,
    CAMERA_UNIT_TYPE_REFLEX_VS_RGB2_NIR2,
    CAMERA_UNIT_TYPE_REFLEX_VS_NIR2,
    NB_UNIT_TYPES
};


enum ReflexImageTypes
{
    IMAGE_TYPE_ORIGINAL,
    IMAGE_TYPE_YUV,
    IMAGE_TYPE_BGR,
    IMAGE_TYPE_MONO,
    NB_IMAGE_TYPES
};


enum ReflexSystems
{
    SYSTEM_ALL = -1,
    SYSTEM1,
    SYSTEM2
};


enum ReflexSensors
{
    SENSOR_ALL = -1,
    SENSOR1,
    SENSOR2,
    SENSOR3,
    SENSOR4
};


enum ReflexSystemStates
{
    SYSTEM_STATE_UNDEFINED = -1,
    SYSTEM_STATE_IDLE,
    SYSTEM_STATE_DETECTION,
    SYSTEM_STATE_RAW_DATA
};


enum ReflexSensorExposureModes
{
    SENSOR_EXPOSURE_TIME_FIXED,
    SENSOR_EXPOSURE_TIME_AUTO
};


enum ReflexCoordinates
{
    X,
    Y,
    Z
};


enum ReflexErrorTypes
{
    ERROR_NONE = 0,
    ERROR_HARDWARE,
    ERROR_NETWORK,
    ERROR_TIME_OUT,
    ERROR_MEMORY,
    ERROR_BOUNDS,
    ERROR_DIMENSIONS,
    ERROR_INITIALIZATION,
    ERROR_DATA_EMPTY,
    ERROR_DATA_SIZE,
    ERROR_DATA_TYPE,
    ERROR_IMAGE_EMPTY,
    ERROR_IMAGE_TYPE,
    ERROR_IMAGE_SIZE,
    ERROR_IMAGE_CONTENT,
    ERROR_FILENAME,
    ERROR_CONFIGURATION,
    ERROR_MISSING_DATA,
    ERROR_FILE_ACCESS_READ,
    ERROR_FILE_ACCESS_WRITE,
    ERROR_FILE_ACCESS_EXECUTE,
    ERROR_XML_EMPTY_ROOT_NODE,
    ERROR_XML_EMPTY_NODE,
    ERROR_INVALID_COMMAND,
    ERROR_UNKNOWN_COMMAND,
    ERROR_INVALID_PARAM,
    ERROR_CAMERA_TRIGGER,
    ERROR_CALIBRATION,
    ERROR_SERVER,
    ERROR_DETECTOR,
    ERROR_CONFIG_DATA,
    ERROR_BROKEN_SEND,
    ERROR_BROKEN_RECV,
    ERROR_NOT_ALLOWED,
    ERROR_NOT_IMPLEMENTED,
    ERROR_BEEPER_ACCESS,
    ERROR_IOCTL,
    ERROR_SOUND_SUPPORT,
    ERROR_SOUND_PARAMETER,
    ERROR_UNDEFINED
};


} // end of namespace reflex


#endif
