#ifndef ENVIRONMENT_H
#define ENVIRONMENT_H

#include <reflex/base/FileAccessObject.hpp>
#include <reflex/geometry/Region2D.hpp>
#include <reflex/geometry/Pose3D.hpp>
#include <reflex/driver/ReflexDriver.hpp>


namespace reflex
{

class Environment : public FileAccessObject
{
public:

    Environment();

    virtual ~Environment();

    virtual void write(cv::FileStorage& fs) const;
    virtual void read(const cv::FileNode& node);

    virtual void addRiskZone(int level, const cv::Ptr<Region2f> region);
    virtual void addCamera(const ReflexCameraUnit& camera, const Pose3d& pose);

    std::vector<std::vector<cv::Ptr<Region2f>>> zones;
    std::vector<Pose3d>                         cameraPose;
    std::vector<ReflexCameraUnit>               cameraUnits;

};

} // end namespace reflex


#endif
