#ifndef VEHICLE_H
#define VEHICLE_H

#include <reflex/base/FileAccessObject.hpp>
#include <reflex/geometry/Region2D.hpp>

namespace reflex
{

class Vehicle : public FileAccessObject
{
public:

    Vehicle();

    virtual ~Vehicle();

    virtual void write(cv::FileStorage& fs) const;
    virtual void read(const cv::FileNode& node);

    virtual int addRiskZone(int level, const cv::Ptr<Region2f> region);

    RegionPolygone2f layoutTop;
    RegionPolygone2f layoutSide;

    std::vector<RegionRect2f> riskZones[3];


protected:

    vector<vector<cv::Ptr<Region2f>>> _zones;
};


} // end namespace reflex


#endif
