#ifndef TARGET_H
#define TARGET_H

#include <reflex/tracking/KalmanFilter.hpp>

namespace reflex
{

class Target
{

public:

    Target();
    Target(const cv::Mat& state, const KalmanFilter::Parameters& filterParams);
    ~Target();

    virtual cv::Mat getState() const { return filter.getState(); }

    //virtual void estimatePosition(double dt, cv::Vec2f& pos2D) const;
    //virtual void estimatePosition(double dt, cv::Vec3f& pos3D) const;

    int id;
    int lifetime;
    float confidence;
    float score;

    cv::Vec3f pos3D;
    cv::Vec3f vel3D;

    cv::Vec2f pos2D;
    cv::Vec2f vel2D;

    /*

    cv::Rect box;
*/
    KalmanFilter filter;

    static int cnt;
};


} // end namespace reflex

#endif
