#ifndef TRACKER_H
#define TRACKER_H

#include <reflex/base/FileAccessObject.hpp>
#include <reflex/tracking/Target.hpp>


namespace reflex
{

class Tracker : public FileAccessObject
{
public:

    enum types { TRACKER_UNDEFINED = -1, TRACKER_REFLECTORS };

    Tracker(int type = TRACKER_UNDEFINED);
    virtual ~Tracker();

    virtual void write(cv::FileStorage& fs) const;
    virtual void read(const cv::FileNode& node);

    virtual void clear();
    virtual void update(const Time& timeStamp);

    std::vector<Target> targets;
    Time timeStamp;

protected:

};

} // end namespace reflex

#endif
